import { Head } from './Head.js';
import { Eyes } from './Eyes.js';
import { Eyebrows } from './Eyebrows.js';
import { Mouth } from './Mouth.js';
import { Nose } from './Nose.js';
import { Hair } from './Hair.js';
import { FaceContainer } from './FaceContainer.js';



const width = window.innerWidth;
const height = window.innerHeight;
const centerX = width / 2;
const centerY = height / 2;


const faceStrokeWidth = 20;
const faceColor = "#FABC98";

// Eyes
const eyeOffsetX = 90;
const eyeOffsetY = -30;
const eyeRadius = 50;
const eyeStrokeWidth = 5;

const irisRadius = eyeRadius * 0.7;
const irisOffsetX = (-irisRadius / 2) + 10;
const irisOffsetY = (irisRadius / 2) - 7;
const irisColor = "#88C978";

const pupilRadius = eyeRadius * 0.2;
const pupilOffsetX = irisOffsetX - (irisRadius / 4);
const pupilOffsetY = irisOffsetY + (irisRadius / 4);

// Eyebrows
const eyebrowOffsetX = -eyeRadius - 10;
const eyebrowOffsetY = -60;
const eyebrowWidth = 120;
const eyebrowHeight = 30;
const eyebrowRotation = 10;

// Hair
// hairPoints start from top left, moving counter-clockwise
//https://www.google.com/url?sa=i&url=https%3A%2F%2Fdannyphantom.fandom.com%2Fwiki%2FDanny_Phantom_(character)&psig=AOvVaw3e8HXuMa2sRLYIV0zBsMQw&ust=1599091918088000&source=images&cd=vfe&ved=0CAIQjRxqFwoTCNi8hOCXyesCFQAAAAAdAAAAABAI
const hairPoints = -centerX*0.6 + "," + -centerY*0.9 + " " +
                   -centerX*0.5 + "," + -centerY*0.1 + " " +
                   -centerX*0.4 + "," + -centerY*0.5 + " " +
                   0 + "," + -centerY*0.4 + " " +
      						 -centerX*0.05 + "," + -centerY*0.6 + " " +
      				   	 centerX*0.6 + "," + -centerY*0.1 + " " +
      				   	 centerX*0.5 + "," + -centerY*0.8 + " " +
      				   	 centerX*0.6 + "," + -centerY*0.7 + " " +
      						 centerX*0.5 + "," + -centerY + " " +
      				   	 0 + "," + -centerY*1.1 + " " +
      						 centerX*0.05 + "," + -centerY*1.3 + " ";
const hairColor = "#ACBCCD";
const hairStrokeColor = "#3E4F5B";
const hairStrokeWidth = 8;

// Nose
const nosePoints = 0 + "," + -centerY*0.2 + " " +
                   centerX*0.01 + "," + centerY*0.1 + " " +
      						 centerX*0.05 + "," + centerY*0.1 + " " +
      						 centerX*0.02 + "," + centerY*0.2 + " ";
const noseStrokeWidth = 5;

// Mouth
const mouthWidth = 7;
const mouthRadius = 90;



export const Face = () => (
  <FaceContainer
    width={width}
    height={height}
    centerX={centerX}
    centerY={centerY}
  >
  	<Head
      radius={centerY - faceStrokeWidth / 2}
      faceColor={faceColor}
      faceStrokeWidth={faceStrokeWidth}
    />

    <Eyes
      eyeOffsetX={eyeOffsetX}
      eyeOffsetY={eyeOffsetY}
      eyeRadius={eyeRadius}
      eyeStrokeWidth={eyeStrokeWidth}

      irisOffsetX={irisOffsetX}
      irisOffsetY={irisOffsetY}
      irisRadius={irisRadius}
      irisColor={irisColor}

      pupilOffsetX={pupilOffsetX}
      pupilOffsetY={pupilOffsetY}
      pupilRadius={pupilRadius}
    />

    <Eyebrows
      eyebrowWidth={eyebrowWidth}
      eyebrowHeight={eyebrowHeight}
      eyeOffsetX={eyeOffsetX}
      eyeOffsetY={eyeOffsetY}
      eyebrowOffsetX={eyebrowOffsetX}
      eyebrowOffsetY={eyebrowOffsetY}
      eyebrowRotation={eyebrowRotation}
    />

    <Mouth
      mouthRadius={mouthRadius}
      mouthWidth={mouthWidth}
    />

    <Nose
      nosePoints={nosePoints}
      noseStrokeWidth={noseStrokeWidth}
    />

    <Hair
      hairPoints={hairPoints}
      hairColor={hairColor}
      hairStrokeColor={hairStrokeColor}
      hairStrokeWidth={hairStrokeWidth}
    />
  </FaceContainer>
);